/*
 * main.c
 *
 *

 */
#include <gps.h>
#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <unistd.h>
#include <syslog.h>
#include <sys/wait.h>
#include <signal.h>
#include "bcm2835.h"
#include "config.h"
#include <curl/curl.h>
#include <nfc/nfc.h>
#include <math.h>
#include <mysql.h>
#include <string.h>

uint8_t HW_init(uint32_t spi_speed, uint8_t gpio);
void usage(char *);
char *KeyA="Test01";
char *KeyB="Test10";
uint8_t debug=0;
int InBuffPointer = 0;
char *InBuff;
int Days = 0;
int Seconds = 0;
time_t StartTime;
time_t EndTime;

static void print_hex(const uint8_t *pbtData, const size_t szBytes)
{
  size_t  szPos;

  for (szPos = 0; szPos < szBytes; szPos++) {
    printf("%02x  ", pbtData[szPos]);
  }
  printf("\n");
}


void SetBlue()
{
	bcm2835_gpio_set(17);
	bcm2835_gpio_clr(22);
	bcm2835_gpio_set(27);
	fprintf(stderr,"Blue LED ON\r\n");
}
void SetRed()
{
	bcm2835_gpio_set(17);
	bcm2835_gpio_set(22);
	bcm2835_gpio_clr(27);
	fprintf(stderr,"Red LED ON\r\n");
}
void SetGreen()
{
	bcm2835_gpio_clr(17);
	bcm2835_gpio_set(22);
	bcm2835_gpio_set(27);
	fprintf(stderr,"Green LED ON\r\n");
}

void SetOff()
{
	bcm2835_gpio_set(17);
	bcm2835_gpio_set(22);
	bcm2835_gpio_set(27);
	fprintf(stderr,"All LED OFF\r\n");
}



void StartBoat()
{
	bcm2835_gpio_clr(15);

	fprintf(stderr,"Boat Started\r\n");
}
void StopBoat()
{
	bcm2835_gpio_set(15);
	fprintf(stderr,"Boat Stopped\r\n");
}
void UnKillBoat()
{
	bcm2835_gpio_clr(4);
	fprintf(stderr,"Kill Switch Off\r\n");

}
void KillBoat()
{
	bcm2835_gpio_set(4);
	fprintf(stderr,"Kill Switch Active\r\n");
	StopBoat();
}

size_t write_callback(char *ptr, size_t size, size_t nmemb, void *userdata)
{
	if (InBuffPointer == 0) memset(InBuff,0,512);
	int Len = size * nmemb;

	if (Len + InBuffPointer > 511) Len = 511 - InBuffPointer;

	memcpy(InBuff,ptr, Len);

		return size * nmemb;
}

int main(int argc, char *argv[]) {

	uint8_t Killed = 0;
	uid_t uid;
	uint8_t SN[10];
	uint16_t CType=0;
	uint8_t SN_len=0;
	char status;
	int tmp,i;
	int BoatID = 0;
	char str[255];
	char *p;
	char sn_str[255];
	pid_t child;
	int max_page=0;
	uint8_t page_step=0;
	int rc;
	FILE * fmem_str;
	char save_mem=0;
	char fmem_path[255];
	uint8_t use_gpio=0;
	uint8_t gpio=255;
	uint32_t spi_speed=10000000L;

	struct gps_data_t gps_data;
	if ((rc = gps_open("localhost", "2947", &gps_data)) == -1) {
	    printf("code: %d, reason: %s\n", rc, gps_errstr(rc));
	    return EXIT_FAILURE;
	}
	gps_stream(&gps_data, WATCH_ENABLE | WATCH_JSON, NULL);

	MYSQL *connection = mysql_init(NULL);
    if (!mysql_real_connect(connection,"127.0.0.1", "roadkil","lexi123", "GPSTracker", 0, NULL, 0)) {
      fprintf(stderr,"Conection error : %s\n", mysql_error(connection));
      exit(1);
    }

    fprintf(stderr,"MySql Connected\r\n");


	char *URL = "http://saetherjacksonyachts.com/boatsystem/checkin.php";

	use_gpio = 1;
	gpio = 18;

	char *LastRFID = (char *)malloc(64);

	char *Buff = (char *)malloc(128);
	InBuff = (char *)malloc(512);
	FILE *BoatFile = fopen("boatid.txt","r");
	if (BoatFile)
	{
		fread(Buff,1,128, BoatFile);
		fclose(BoatFile);
	}
	sscanf(Buff,"%d", &BoatID);
	fprintf(stderr,"I Am Boat %d\r\n", BoatID);



	spi_speed = 5000;
	if (HW_init(spi_speed,gpio)) return 1;
	fprintf(stderr,"Setting default pins\r\n");

	//InitRc522();

	bcm2835_gpio_fsel(17,BCM2835_GPIO_FSEL_OUTP );
	bcm2835_gpio_fsel(22,BCM2835_GPIO_FSEL_OUTP );
	bcm2835_gpio_fsel(27,BCM2835_GPIO_FSEL_OUTP );
	//bcm2835_gpio_fsel(23,BCM2835_GPIO_FSEL_OUTP );
	bcm2835_gpio_fsel(4,BCM2835_GPIO_FSEL_OUTP );
	bcm2835_gpio_fsel(15,BCM2835_GPIO_FSEL_OUTP );

	fprintf(stderr,"Pins Set\r\n");
	StopBoat();
	//bcm2835_gpio_clr(17);
	//bcm2835_gpio_clr(22);
	//bcm2835_gpio_clr(27);


	SetOff();


	int  Active = 0;

	int Counter = 0;
	int LastCheckin = 0;

	 nfc_device *pnd;
  nfc_target nt;

  // Allocate only a pointer to nfc_context
  nfc_context *context;

  // Initialize libnfc and set the nfc_context
  nfc_init(&context);
  if (context == NULL) {
    printf("Unable to init libnfc (malloc)\n");
    exit(EXIT_FAILURE);
  }

  // Display libnfc version
  const char *acLibnfcVersion = nfc_version();
  (void)argc;
  printf("%s uses libnfc %s\n", argv[0], acLibnfcVersion);

  // Open, using the first available NFC device which can be in order of selection:
  //   - default device specified using environment variable or
  //   - first specified device in libnfc.conf (/etc/nfc) or
  //   - first specified device in device-configuration directory (/etc/nfc/devices.d) or
  //   - first auto-detected (if feature is not disabled in libnfc.conf) device
  pnd = nfc_open(context, NULL);

  if (pnd == NULL) {
    printf("ERROR: %s\n", "Unable to open NFC device.");
    exit(EXIT_FAILURE);
  }
  // Set opened NFC device to initiator mode
  if (nfc_initiator_init(pnd) < 0) {
    nfc_perror(pnd, "nfc_initiator_init");
    exit(EXIT_FAILURE);
  }

  printf("NFC reader: %s opened\n", nfc_device_get_name(pnd));

  // Poll for a ISO14443A (MIFARE) tag
  const nfc_modulation nmMifare = {
    .nmt = NMT_ISO14443A,
    .nbr = NBR_106,
  };
bool Added = false;

// Old code
		char *query = (char *)malloc (1024);
  if (query == NULL)
  {
		fprintf(stderr,"Out of memory");
		exit(1);
  }

	while(1 == 1) {

		fprintf(stderr,"Start Loop\r\n");


		fprintf(stderr,"Check Fuel\r\n");
		char Send[4];

		Send[0] = 0x1;
		Send[1] = 0x80;
		Send[2] = 0x0;

		bcm2835_spi_transfernb((char*)&Send, Buff, 3);

		long FuelLevel = Buff[2];
		FuelLevel += (Buff[1] * 256);


		fprintf(stderr,"Fuel Value: %02X %02X %02X (%d)\r\n", Buff[0],Buff[1],Buff[2], FuelLevel);

		// Get Position
		if (Counter % 10 == 0) // Only save GPS every 10 loops.. Too much data otherwise
		{
			if (gps_waiting (&gps_data, 2000000)) {
	        /* read data */
	        if ((rc = gps_read(&gps_data)) == -1) {
	            printf("error occured reading gps data. code: %d, reason: %s\n", rc, gps_errstr(rc));
	        } else {

	            /* Display data from the GPS receiver. */
	            if ((gps_data.status == STATUS_FIX) &&
	                (gps_data.fix.mode == MODE_2D || gps_data.fix.mode == MODE_3D) &&
	                !isnan(gps_data.fix.latitude) &&
	                !isnan(gps_data.fix.longitude)) {
	                    //gettimeofday(&tv, NULL);

	                    sprintf(query, "INSERT INTO GPS (Lat, Lng, Speed, Bearing, FuelVoltage, Active) VALUES ('%f','%f','%f', '%f','%i', '%i')", gps_data.fix.latitude, gps_data.fix.longitude, gps_data.fix.speed, gps_data.fix.track,FuelLevel,Active);

	                    fprintf(stderr,"%s\r\n",query);

						mysql_query(connection, query);

						Added  = true;

	                    printf("latitude: %f, longitude: %f, speed: %f, bearing: %f\n", gps_data.fix.latitude, gps_data.fix.longitude, gps_data.fix.speed, gps_data.fix.track);
	            } else {
	                printf("no GPS data available\n");
	            }
	        }
	    }
	   }

		Counter++;
			LastCheckin++;
		//	usleep(200000);
			if (Counter > 1)
			{
					if (Counter % 2 == 0)
					{

							if (!Active) SetOff();
							else
							{
								time_t Now = time(NULL);
								if (Now > EndTime)
								{
									Active = 0;
									SetOff();
									StopBoat();
								}
							}
					}
					else
					{
						if (!Active) SetBlue();
					}
			}
			if (LastCheckin > 600)
			{
				fprintf(stderr,"Performing Check In\r\n");

				CURL *curl;
				CURLcode res;
				curl = curl_easy_init();
				LastCheckin = 0;

				if (curl)
				{
					sprintf(Buff,"%s?RFID=%s&BoatID=%d", URL, LastRFID,BoatID);

					fprintf(stderr,"Contacting %s\r\n", Buff);

					curl_easy_setopt(curl, CURLOPT_URL, Buff);
					curl_easy_setopt(curl, CURLOPT_FOLLOWLOCATION, 1L);
					curl_easy_setopt(curl, CURLOPT_WRITEFUNCTION, write_callback);
					res = curl_easy_perform(curl);
					if (res != CURLE_OK)
					{

					}
					else
					{
						if (strncmp(InBuff, "KILL",4) == 0)
						{
							Active = 0;
							StopBoat();
							KillBoat();
							SetRed();
							usleep(2000000);
							SetOff();
							Killed = 1;
						}
						else
						{
							Killed = 0;
							UnKillBoat();

							fprintf(stderr,"%s\r\n",InBuff);
							if (strncmp(InBuff, "BAD",3) == 0)
							{
								Active = 0;
								StopBoat();
							}
							else
							{
									Active = 1;
									SetGreen();
									StartBoat();
									sscanf(InBuff+2,"%d %d", &Days, &Seconds);
									fprintf(stderr,"Online for %d Days\r\n", Days);

									StartTime = time(NULL);
									fprintf(stderr,"Current Time Stamp %d\r\n",StartTime);
									EndTime = StartTime + Seconds;
									fprintf(stderr,"Expire Time Stamp %d\r\n",EndTime);

							}
						}
					}
					curl_easy_cleanup(curl);
				}

			}

		 if (!(nfc_initiator_select_passive_target(pnd, nmMifare, NULL, 0, &nt) > 0)) {
	


		}
		else
		{
		//for debugging

		    long i =0;

		    for (i =0; i < nt.nti.nai.szUidLen; i++)
		    {
		    	 sprintf(&sn_str[i*2], "%02X", nt.nti.nai.abtUid[i]);
		    }

		    fprintf(stderr, "RFID: %s", &sn_str);

		Days = 0;
		SetBlue();
		InBuffPointer = 0;
		CURL *curl;
		CURLcode res;
		curl = curl_easy_init();
		LastCheckin = 0;

		if (curl)
		{

fprintf(stderr,"Do CURL\r\n");


			sprintf(LastRFID,"%s", &sn_str);

			sprintf(Buff,"%s?RFID=%s&BoatID=%d", URL,LastRFID,BoatID);
			//fprintf(stderr,"Connecting To: %s\r\n", Buff);

			fprintf(stderr,"Contacting %s\r\n", Buff);


			curl_easy_setopt(curl, CURLOPT_URL, Buff);
			curl_easy_setopt(curl, CURLOPT_FOLLOWLOCATION, 1L);
			curl_easy_setopt(curl, CURLOPT_WRITEFUNCTION, write_callback);


			res = curl_easy_perform(curl);
			if (res != CURLE_OK)
			{
				SetRed();
				usleep(500000);
				SetBlue();
				usleep(500000);
				SetRed();
				usleep(500000);
				SetOff();
				fprintf(stderr,"Network Error %s\r\n",curl_easy_strerror(res));
			}
			else
			{
				fprintf(stderr,"CURL OK \r\n");
				SetGreen();

				fprintf(stderr,"%s\r\n",InBuff);
				if (strncmp(InBuff, "KILL",4) == 0)
				{
					Active = 0;
					StopBoat();
					KillBoat();
					SetRed();
					usleep(2000000);
					SetOff();
					Killed = 1;
				}
				else
				{
					Killed = 0;
					UnKillBoat();

					fprintf(stderr,"%s\r\n",InBuff);
					if (strncmp(InBuff, "BAD",3) == 0)
					{
						Active = 0;
						StopBoat();
						SetRed();
						usleep(2000000);
						SetOff();
					}
					else
					{
							Active = 1;
							SetGreen();
							StartBoat();
							sscanf(InBuff+2,"%d %d", &Days, &Seconds);
							fprintf(stderr,"Online for %d Days\r\n", Days);

							StartTime = time(NULL);
							fprintf(stderr,"Current Time Stamp %d\r\n",StartTime);
							EndTime = StartTime + Seconds;
							fprintf(stderr,"Expire Time Stamp %d\r\n",EndTime);

					}
				}
			}
			curl_easy_cleanup(curl);
		}
		else
		{
				SetRed();
				usleep(500000);
				SetGreen();
				usleep(500000);
				SetRed();
				usleep(500000);
			SetOff();
		}

		fprintf(stderr,"End Read Loop\r\n");


		if (use_gpio) bcm2835_gpio_write(gpio, HIGH);

		if (use_gpio) bcm2835_gpio_write(gpio, LOW);
	}
}

// Close NFC device
  nfc_close(pnd);
  // Release the context
  nfc_exit(context);
	//bcm2835_spi_end();
	bcm2835_close();

gps_stream(&gps_data, WATCH_DISABLE, NULL);
gps_close (&gps_data);

//	close_config_file();
	return 0;

}


uint8_t HW_init(uint32_t spi_speed, uint8_t gpio) {


	uint16_t sp;

	sp=(uint16_t)(250000L/spi_speed);
	if (!bcm2835_init()) {
		syslog(LOG_DAEMON|LOG_ERR,"Can't init bcm2835!\n");
		return 1;
	}
	if (gpio<28) {
		bcm2835_gpio_fsel(gpio, BCM2835_GPIO_FSEL_OUTP);
		bcm2835_gpio_write(gpio, LOW);
	}

	bcm2835_spi_begin();
	bcm2835_spi_setBitOrder(BCM2835_SPI_BIT_ORDER_MSBFIRST);      // The default
	bcm2835_spi_setDataMode(BCM2835_SPI_MODE0);                   // The default
	bcm2835_spi_setClockDivider(BCM2835_SPI_CLOCK_DIVIDER_256); // The default
	bcm2835_spi_chipSelect(BCM2835_SPI_CS0);                      // The default
	bcm2835_spi_setChipSelectPolarity(BCM2835_SPI_CS0, LOW);      // the default


	return 0;
}

void usage(char * str) {
	printf("Usage:\n%s [options]\n\nOptions:\n -d\t Debug mode\n\n",str);
}
